unit Main;

interface

uses Windows,Messages,SysUtils,Classes,Graphics,Controls,Forms,Dialogs,StdCtrls,
     RegDeRegServer,AxCtrls,ExtCtrls,ShutDownRequest, Grids;

type
  TForm1 = class(TForm)
    PulseTimer: TTimer;
    DateTimeLbl: TLabel;
    GroupBox1: TGroupBox;
    RegSerBtn: TButton;
    UnRegBtn: TButton;
    SDButton: TButton;
    Panel1: TPanel;
    Label2: TLabel;
    ClientConLbl: TLabel;
    GrpCountLbl: TLabel;
    Label1: TLabel;
    CloseBtn: TButton;
    StringGrid1: TStringGrid;
    Label3: TLabel;
    Edit1: TEdit;
    procedure RegSerBtnClick(Sender: TObject);
    procedure CloseBtnClick(Sender: TObject);
    procedure SDButtonClick(Sender: TObject);
    procedure PulseTimerTimer(Sender: TObject);
    procedure UnRegBtnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  public
   clientsConnected:integer;
   procedure UpdateGroupCount;
  end;

var
  Form1: TForm1;


implementation

{$R *.DFM}

uses DateUtils, ServImpl, OPCCOMN, Globals, ActiveX, DataPointsUnit;

procedure TForm1.RegSerBtnClick(Sender: TObject);
begin
 RegisterTheServer(serverName);
end;

procedure TForm1.CloseBtnClick(Sender: TObject);
begin
 Close;
end;

procedure TForm1.SDButtonClick(Sender: TObject);
var
 i:integer;
 Obj: Pointer;
begin
 ShutDownDlg:=nil;
 try
  Application.CreateForm(TShutDownDlg,ShutDownDlg);
  for i:= low(theServers) to high(theServers) do
   begin
    ShutDownDlg.RadioGroup1.controls[i].enabled:=(theServers[i] <> nil);
    if ShutDownDlg.RadioGroup1.controls[i].enabled then
     ShutDownDlg.RadioGroup1.itemIndex:=i;        //select the last one why...
   end;                                           //just so one is selected ;)
  if ShutDownDlg.ShowModal = mrOk then
   begin
    i:=ShutDownDlg.RadioGroup1.itemIndex;
    if Assigned(theServers[i]) then
     if theServers[i].ClientIUnknown <> nil then
      if Succeeded(theServers[i].ClientIUnknown.QueryInterface(IOPCShutdown,Obj)) then
       IOPCShutdown(Obj).ShutdownRequest('MRD IOPCShutdown request.')
      else
       ShowMessage('The client does not support IOPCShutdown.');
   end;
  ShutDownDlg.Release;
 finally
 end;
end;

procedure TForm1.PulseTimerTimer(Sender: TObject);
var
 i:integer;
 cTime:TDateTime;
begin
 PulseTimer.enabled:=false;
 try
  cTime:= Now;

 //0     complete time and date
 //1     complete date
 //2     day
 //3     month
 //4     year
 //5     complete time
 //6     hour
 //7     minute
 //8     second
 //9     millisecond
 //10    Test_Tag_1
 //11    Test_Tag_1 Inverted
 //12    Test_Tag_2
 //13    Test_Tag_2 Inverted


  TRealDataPoint(rDataPoints[10]).aWord:= SecondOf(Now);
  TRealDataPoint(rDataPoints[11]).aWord:=
                         (not TRealDataPoint(rDataPoints[10]).aWord) and $FFFF;

  TRealDataPoint(rDataPoints[12]).aWord:= MillisecondOf(Now);
  TRealDataPoint(rDataPoints[13]).aWord:=
                         (not TRealDataPoint(rDataPoints[12]).aWord) and $FFFF;

  DecodeDate(cTime,TRealDataPoint(rDataPoints[4]).aWord,
                   TRealDataPoint(rDataPoints[3]).aWord,
                   TRealDataPoint(rDataPoints[2]).aWord);

  DecodeTime(cTime,TRealDataPoint(rDataPoints[6]).aWord,
                   TRealDataPoint(rDataPoints[7]).aWord,
                   TRealDataPoint(rDataPoints[8]).aWord,
                   TRealDataPoint(rDataPoints[9]).aWord);

  TRealDataPoint(rDataPoints[0]).aString:=
                                     TimeToStr(cTime) + ' ' + DateToStr(cTime);
  DateTimeLbl.Caption:=TRealDataPoint(rDataPoints[0]).aString;

  TRealDataPoint(rDataPoints[1]).aString:=
        DateToStr(EncodeDate(TRealDataPoint(rDataPoints[4]).aWord,
                             TRealDataPoint(rDataPoints[3]).aWord,
                             TRealDataPoint(rDataPoints[2]).aWord));

  TRealDataPoint(rDataPoints[5]).aString:=
        TimeToStr(EncodeTime(TRealDataPoint(rDataPoints[6]).aWord,
                             TRealDataPoint(rDataPoints[7]).aWord,
                             TRealDataPoint(rDataPoints[8]).aWord,
                             TRealDataPoint(rDataPoints[9]).aWord));

 For i:= 1 to 14 do
  Stringgrid1.Cells[3, i]:= IntToStr(TRealDataPoint(rDataPoints[i - 1]).aWord);

  for i:= low(theServers) to high(theServers) do
   if Assigned(theServers[i]) then theServers[i].TimeSlice(cTime);

 finally
  PulseTimer.enabled:=true;
 end;
end;

procedure TForm1.UnRegBtnClick(Sender: TObject);
begin
 UnRegisterTheServer(serverName);
end;

procedure TForm1.UpdateGroupCount;
var
 i,g:integer;
begin
 if Application.Terminated then Exit;
 clientsConnected:= 0;
 g:=0;
 for i:= low(theServers) to high(theServers) do
  if Assigned(theServers[i]) then
   begin
    clientsConnected:=succ(clientsConnected);
    if Assigned(theServers[i].grps) then
     g:= g + theServers[i].grps.count;
    if Assigned(theServers[i].pubGrps) then
     g:= g + theServers[i].pubGrps.count;
   end;

 Form1.ClientConLbl.caption:= IntToStr(clientsConnected);
 GrpCountLbl.caption:= IntToStr(g);
 SDButton.enabled:= (clientsConnected  > 0);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
 Stringgrid1.Cells[0, 0]:= 'Prop ID';
 Stringgrid1.Cells[1, 0]:= 'Tag Name';
 Stringgrid1.Cells[2, 0]:= 'Data Type';
 Stringgrid1.Cells[3, 0]:= 'Actual Value';

 Stringgrid1.Cells[0, 1]:= '5000';
 Stringgrid1.Cells[1, 1]:= 'Complete';
 Stringgrid1.Cells[2, 1]:= 'VT_BSTR';

 Stringgrid1.Cells[0, 2]:= '5001';
 Stringgrid1.Cells[1, 2]:= 'Date.Complete';
 Stringgrid1.Cells[2, 2]:= 'VT_BSTR';

 Stringgrid1.Cells[0, 3]:= '5002';
 Stringgrid1.Cells[1, 3]:= 'Date.Parts.Day';
 Stringgrid1.Cells[2, 3]:= 'VT_UI2';

 Stringgrid1.Cells[0, 4]:= '5003';
 Stringgrid1.Cells[1, 4]:= 'Date.Parts.Month';
 Stringgrid1.Cells[2, 4]:= 'VT_UI2';

 Stringgrid1.Cells[0, 5]:= '5004';
 Stringgrid1.Cells[1, 5]:= 'Date.Parts.Year';
 Stringgrid1.Cells[2, 5]:= 'VT_UI2';

 Stringgrid1.Cells[0, 6]:= '5005';
 Stringgrid1.Cells[1, 6]:= 'Time.Complete';
 Stringgrid1.Cells[2, 6]:= 'VT_BSTR';

 Stringgrid1.Cells[0, 7]:= '5006';
 Stringgrid1.Cells[1, 7]:= 'Time.Parts.Hour';
 Stringgrid1.Cells[2, 7]:= 'VT_UI2';

 Stringgrid1.Cells[0, 8]:= '5007';
 Stringgrid1.Cells[1, 8]:= 'Time.Parts.Minute';
 Stringgrid1.Cells[2, 8]:= 'VT_UI2';

 Stringgrid1.Cells[0, 9]:= '5007';
 Stringgrid1.Cells[1, 9]:= 'Time.Parts.Second';
 Stringgrid1.Cells[2, 9]:= 'VT_UI2';

 Stringgrid1.Cells[0, 10]:= '5008';
 Stringgrid1.Cells[1, 10]:= 'Time.Parts.Millisecond';
 Stringgrid1.Cells[2, 10]:= 'VT_UI2';

 Stringgrid1.Cells[0, 11]:= '5009';
 Stringgrid1.Cells[1, 11]:= 'Test_Tag_1.Actual';
 Stringgrid1.Cells[2, 11]:= 'VT_UI2';

 Stringgrid1.Cells[0, 12]:= '5010';
 Stringgrid1.Cells[1, 12]:= 'Test_Tag_1.Inverted';
 Stringgrid1.Cells[2, 12]:= 'VT_UI2';

 Stringgrid1.Cells[0, 13]:= '5011';
 Stringgrid1.Cells[1, 13]:= 'Test_Tag_2.Actual';
 Stringgrid1.Cells[2, 13]:= 'VT_UI2';

 Stringgrid1.Cells[0, 14]:= '5012';
 Stringgrid1.Cells[1, 14]:= 'Test_Tag_2.Inverted';
 Stringgrid1.Cells[2, 14]:= 'VT_UI2';

 Edit1.Text:= serverName;

 SetUpRealDataPoints;
 UpdateGroupCount;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 FreeRealDataPoints;
end;

procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
 if (clientsConnected > 0) then
  CanClose:=(MessageDlg('Clients are connected. Are you sure you want to quit?',
                        mtConfirmation,[mbYes,mbNo],0) =  mrYes)
 else
  CanClose:=true;
end;

end.
